#include "scr.h"
#include "pm.h"
#include "task.h"



void bootinfo(dword magic, struct multiboot_info *mbi);


int main(dword magic, struct multiboot_info *mbi)
{
 dword msize=0;
 extern char end;
 kernelend=(dword) &end;
 memorysize=mbi->mem_upper*1024+0x100000;
 msize=memorysize/1024;
 init_video();
 bootinfo(magic,mbi);
 gdt_install();
 idt_install();
 isrs_install();
 irq_install();
 msize/=1024;
 enable();		//Enable IRQs
 printf("\nmemory size is %uMB \n",msize);
 printf("\n");
 phmanager();	//enable physical memory manager
 initpaging(start_vga,pagetop(kernelend));//enable paging
 init_task();	//enable multitasking
 far_jmp(0x30);	//selector of task()
 printf("Done again\n");
 for(;;);
}

void bootinfo(dword magic, struct multiboot_info *mbi)
{
 char *device[] = { "floppy A", "hard disk"};
     // is magic number valid?
  if(magic != multiboot_magic)
   {
    printf("not grub\n");
    printf("Invalid magic number %x\n", magic);
   }
  else
   {
    printf("grub\n");
   }

     // if bit 1 of flags is set, then memory info is available
  if (mbi->flags & 1)
   {
    printf ("Lower memory = %uKB\n",(unsigned) mbi->mem_lower);
    printf ("Upper memory = %uKB\n", (unsigned) mbi->mem_upper);
   }
     // if bit 2 of flags is set, then boot device info is available
  char bootdvc = ((unsigned) mbi->boot_device >> 24) & 0xf;
  char *boot = (bootdvc)?device[1]:device[0];
  if (mbi->flags & 2)
   printf ("Boot device = %s\n", boot);
}

