#ifndef __PAGING_H
#define __PAGING_H

#include "defs.h"
#include "scr.h"

/***********stack***************************/

struct stack
{
 int top;
 dword *frames;
};__attribute__((packed));

struct stack s;

void *bootalloc(dword size);

int isempty();
void push(dword index);
dword pop();
int size();
void stack(dword nbframes);

/************physical manager****************/

#define page_shift 12
#define page_size  4096
#define page_mask ~(page_size-1)

#define	start_page	0x1000
#define	start_vga	0xA0000


dword nbframes;
dword memtop;
dword kerneltop;

static const dword zero=1;

dword pagebase(dword address);
dword pagetop(dword address);

void phmanager();
dword allocframe(dword flags);
void freeframe(dword index);
dword freepages();

/********************paging*******************/

#define self_map_index		255
#define zone_mapping		(self_map_index<<22)
#define zone_mapping_size	4194304
#define page_dir		(zone_mapping+(self_map_index<<12))
#define self_pde_map		(page_dir+(self_map_index*4))
#define user_zone		(zone_mapping+zone_mapping_size)

//user zone starts after the first Giga

#define vpage_shift		12
#define vpage_size		4096

#define vpage_mask		(vpage_size-1)
#define pde_flags_mask		(vpage_size-1)
#define pte_flags_mask		(vpage_size-1)


#define pde_shift		22
#define pte_shift		12

#define present			1
#define write			2
#define user		4
#define write_through	8
#define cache_disable	16
#define acessed		32
#define dirty		64
#define pt_attrib	128
#define global		256

typedef unsigned int    pde_t;
typedef unsigned int    pte_t;

#define null_pde	0
#define null_pte	0
dword *pd_u;
/************paging********************/
dword pbdr,basedeneid,topdeneid;

void makepde(pde_t *pde,physaddr_t paddr,dword flags);
void makepte(pte_t *pte,physaddr_t paddr,dword flags);
dword pdeindex(virtaddr_t vaddr);
dword pteindex(virtaddr_t vaddr);
dword pageoffset(virtaddr_t vaddr);
pde_t *pdeaddr(virtaddr_t vaddr);
pte_t *pteaddr(virtaddr_t vaddr);
int issystemaddr(virtaddr_t vaddr);
int ismapaddr(virtaddr_t vaddr);
void invlpage(virtaddr_t page);
pde_t *initpaging(physaddr_t kbase,physaddr_t ktop);



#endif