#include "task.h"


dword total_tasks=2, cur_task=0;
dword tss_selector[2]={0x30,0x38};

extern isr0();



void init_task()
{
 disable();
 
 
 unsigned int i=0;
 for(i;i<max_tasks;i++)
  {
   tss[i].trace=0;
   tss[i].io_map_addr=sizeof(TSS);
   tss[i].ldtr=0;
   if (i) {
   tss[i].fs=tss[i].gs=0;
   tss[i].ds=tss[i].es=tss[i].ss=0x20 | 3;
   tss[i].cs=0x18 | 3;
   tss[i].eflags=0x3202L;
   tss[i].esp=(dword)&task_stack[i];	//stack for user programes
   tss[i].ss0=0x10;
   tss[i].esp0=(dword)&pl0_stack[i];	//stack for kernel
   }
  }
 tss[1].eip=(dword)&task;
 tss[0].cr3=pbdr;	//page directory for supervisor
 tss[1].cr3=pd_u;	//page directory for user
 ltr(0x28);

 enable();
}

void ltr(unsigned short selector)
{
  asm ("ltr %0": :"r" (selector));
}

void task()
{
 printf("Hello from task()\n");
 asm ("iret");			//back to PL0 main();
}




void far_jmp(unsigned int selector) 
{ 
   __asm__ __volatile__ ("lcall *(%0)\n" : :"r"((void *)&selector -4)  : "memory"); 
}



void scheduler()
{
 while(1)
  {
   delay(250);
   if(++cur_task>=total_tasks)
     cur_task=0;
   far_jmp(tss_selector[cur_task]);
  }
}





















